#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=icon.ico
#AutoIt3Wrapper_Res_Comment=Dock for WinPE
#AutoIt3Wrapper_Res_Description=Dock for WinPE
#AutoIt3Wrapper_Res_Fileversion=1.0.0.3
#AutoIt3Wrapper_Res_LegalCopyright=Free
#AutoIt3Wrapper_Res_requestedExecutionLevel=requireAdministrator
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.12.0
	Author:         myName

	Script Function:
	Template AutoIt script.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here


#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include "GUICtrlPic.au3"
#include <WindowsConstants.au3>
#include <WinAPI.au3>
#include <FontConstants.au3>

;#include <GDIPlus.au3>
;_GDIPlus_Startup()

GUISetState()


Opt('TrayIconHide', 1)

$bFirst = True
$TotalApps = 0
$IniFileApps = @ScriptDir & "\AppsList.ini"


; Read the INI section names. This will return a 1 dimensional array.
Local $aArray = IniReadSectionNames($IniFileApps)
Local $app[32][5]


; Check if an error occurred.
If Not @error Then
	; Enumerate through the array displaying the section names.
	For $i = 1 To $aArray[0]
		; Read the INI section labelled 'General'. This will return a 2 dimensional array.
		$aArray2 = IniReadSection($IniFileApps, $aArray[$i])

		; Check if an error occurred.
		If Not @error Then
			$TotalApps = $TotalApps + 1
			$app[$TotalApps][1] = $aArray[$i] ;Name
			$app[$TotalApps][4] = False ;Hilight
			; Enumerate through the array displaying the keys and their respective values.
			For $j = 1 To $aArray2[0][0]
				;MsgBox($MB_SYSTEMMODAL, "", "Key: " & $aArray2[$j][0] & @CRLF & "Value: " & $aArray2[$j][1])
				Switch StringLower($aArray2[$j][0])
					Case "icon"
						$app[$TotalApps][2] = $aArray2[$j][1] ;Icon
					Case "exe"
						$app[$TotalApps][3] = $aArray2[$j][1] ;EXE
				EndSwitch
			Next
		EndIf
	Next
EndIf

$BGColor = 0x000000
$BorderX = 10
$IconW = 48
$Spacing = 50

$FormHeight = 50
$FormLeft = 10
$FormTop = @DesktopHeight - $FormHeight

$Sh=2
$CaptionHeight = 25
$CaptionWidth = 1000
$CaptionSpace = 5
$CaptionFont = "Segoe UI"
$CaptionFontSize = 14
$CaptionColor = 0xFFFFFF
$CaptionColorOutline = 0x000000


$IniFile = @ScriptDir & "\Options.ini"
$aArray = IniReadSection($IniFile, "Options")
; Check if an error occurred.
If Not @error Then
	; Enumerate through the array displaying the keys and their respective values.
	For $j = 1 To $aArray[0][0]
		;MsgBox($MB_SYSTEMMODAL, "", "Key: " & $aArray2[$j][0] & @CRLF & "Value: " & $aArray2[$j][1])
		Switch StringLower($aArray[$j][0])
			Case "bgcolor"
				$BGColor = $aArray[$j][1]
			Case "borderx"
				$BorderX = $aArray[$j][1]
			Case "spacing"
				$Spacing = $aArray[$j][1]
			Case "height"
				$FormHeight = $aArray[$j][1]
			Case "posx"
				$FormLeft = $aArray[$j][1]
			Case "captionheight"
				$CaptionHeight = $aArray[$j][1]
			Case "captionspace"
				$CaptionSpace = $aArray[$j][1]
			Case "captionfont"
				$CaptionFont = $aArray[$j][1]
			Case "captionfontsize"
				$CaptionFontSize = $aArray[$j][1]
			Case "captioncolor"
				$CaptionColor = $aArray[$j][1]
			Case "captioncoloroutline"
				$CaptionColorOutline = $aArray[$j][1]
			Case "shadowspread"
				$Sh = $aArray[$j][1]
		EndSwitch
	Next
EndIf

$FormWidth = $TotalApps * $Spacing + ($BorderX * 2) - (($Spacing - $IconW))


$Form1 = GUICreate("Form1", $FormWidth, $FormHeight, -1, -1, $WS_POPUP, $WS_EX_TOPMOST) ;, $WS_EX_LAYERED)  ;, BitOR($WS_EX_LAYERED, $WS_EX_TOPMOST)
;$Form1 = GUICreate("Form1", $FormWidth, $FormHeight, -1, -1, $WS_POPUP, BitOR($WS_EX_LAYERED, $WS_EX_TOPMOST))
;GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUISetBkColor($BGColor)


$hPic_background = GUICtrlCreatePic(@ScriptDir & "\BG.jpg", 0, 0, 0, 0)
;; create more controls here
GUICtrlSetState($hPic_background, $GUI_DISABLE)

WinSetOnTop($Form1, "", 1)

Local $Icon[32]
Local $Button[32]
Local $GO[32]

For $i = 1 To $TotalApps
	If FileExists(@ScriptDir & "\" & $app[$i][2] & ".png") Then
		$Icon[$i] = @ScriptDir & "\" & $app[$i][2] & ".png"
	Else
		;Glenn
		$Icon[$i] = @ScriptDir & "\Unknown.png"
	EndIf
	GUICtrlCreatePic(@ScriptDir & "\" & $app[$i][2] & ".png", 0, 0, 48, 48)
	GuiCtrlSetState(-1, $GUI_DISABLE)
	$Button[$i] = _GUICtrlPic_Create($Icon[$i], $BorderX + ($Spacing * ($i - 1)), 1, 48, 48)
	$GO[$i] = False
Next

;$Label = GUICtrlCreateLabel("Test",0,55,$FormWidth,20) ;For Debugging

$Form2 = GUICreate("Form2", $CaptionWidth, $CaptionHeight, -1, -1, $WS_POPUP, $WS_EX_LAYERED, $Form1)

GUISetBkColor(0x010101)
_WinAPI_SetLayeredWindowAttributes($Form2, 0x010101, 255)


GUISetFont($CaptionFontSize, 500, 0, $CaptionFont, $Form1, 5)
GUISetFont($CaptionFontSize, 500, 0, $CaptionFont, $Form2, 5)

$ShCount = ($Sh*8)+8
$Dist = 0
Dim $Caption[$ShCount+8]

For $k= 1 To $ShCount Step 8
	$Dist = $Dist + 1
	$Caption[$k] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh-$Dist, $Sh-$Dist, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k], $GUI_BKCOLOR_TRANSPARENT)
	$Caption[$k+1] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh+$Dist, $Sh-$Dist, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+1], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+1], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+1], $GUI_BKCOLOR_TRANSPARENT)
	$Caption[$k+2] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh-$Dist, $Sh+$Dist, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+2], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+2], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+2], $GUI_BKCOLOR_TRANSPARENT)
	$Caption[$k+3] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh+$Dist, $Sh+$Dist, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+3], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+3], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+3], $GUI_BKCOLOR_TRANSPARENT)

	$Caption[$k+4] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh-$Dist, $Sh, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+4], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+4], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+4], $GUI_BKCOLOR_TRANSPARENT)
	$Caption[$k+5] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh, $Sh-$Dist, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+5], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+5], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+5], $GUI_BKCOLOR_TRANSPARENT)
	$Caption[$k+6] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh+$Dist, $Sh, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+6], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+6], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+6], $GUI_BKCOLOR_TRANSPARENT)
	$Caption[$k+7] = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh, $Sh+$Dist, $CaptionWidth, $CaptionHeight)
	GUICtrlSetColor($Caption[$k+7], $CaptionColorOutline)
	GUICtrlSetFont($Caption[$k+7], $CaptionFontSize, 500, 0, $CaptionFont, 5)
	GUICtrlSetBkColor($Caption[$k+7], $GUI_BKCOLOR_TRANSPARENT)
Next

$Caption4 = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh, $Sh, 1024, 200) ;Main White Text
GUICtrlSetColor($Caption4, $CaptionColor)
GUICtrlSetFont($Caption4, $CaptionFontSize, 500, 0, $CaptionFont, 5)
GUICtrlSetBkColor($Caption4, $GUI_BKCOLOR_TRANSPARENT)


$Caption5 = GUICtrlCreateLabel("TestTestTestTestTestTestTestTestTestTestTestTestTestTest", $Sh, 200, 1024, $CaptionHeight)
GUICtrlSetColor($Caption5, $CaptionColor)
GUICtrlSetFont($Caption5, $CaptionFontSize, 500, 0, $CaptionFont, 5)
GUICtrlSetBkColor($Caption5, $GUI_BKCOLOR_TRANSPARENT)

;_WinAPI_SetWindowPos($Form1, $HWND_TOPMOST + $HWND_TOP, 0, 0, 0, 0, BitOR($SWP_NOMOVE,$SWP_NOSIZE))

_WinAPI_SetWindowPos($Form1, $HWND_TOPMOST, $FormLeft, $FormTop, $FormWidth, $FormHeight, BitOR($SWP_SHOWWINDOW, $SWP_NOACTIVATE))

GUISetState(@SW_SHOW, $Form1)


Global $SystemRoot = EnvGet("systemroot")
Global $SystemDrive = EnvGet("systemdrive")
Global $CDDRIVE = ""
Global $CDDRIVE2 = ""

Global $Tem = 0
Global $Test = 0

$LivePE=False
If FileExists("X:\sources\setup.exe") Then

	;Get CDDrive Varible

	;SetErrorMode(SEM_FAILCRITICALERRORS);
	DllCall("kernel32.dll", "dword", "SetErrorMode", "dword", 1) ; SEM_FAILCRITICALERRORS
	RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Windows", "ErrorMode", "REG_DWORD", "2")

	$Test = Asc("A")
	For $Tem = 2 To 25
		If FileExists(Chr($Test + $Tem) & ":\sources\$Scripts") Then
			$CDDRIVE2 = Chr($Test + $Tem) & ":"
			If FileExists(Chr($Test + $Tem) & ":\sources\boot.wim") Then
				$CDDRIVE = Chr($Test + $Tem) & ":"
				ExitLoop
			EndIf
		EndIf
	Next
	If $CDDRIVE = "" Then $CDDRIVE = $CDDRIVE2
	If $CDDRIVE = "" Then
		For $Tem = 2 To 25
			If FileExists(Chr($Test + $Tem) & ":\sources\boot.wim") Then
				$CDDRIVE = Chr($Test + $Tem) & ":"
				ExitLoop
			EndIf
		Next
	EndIf

	If $CDDRIVE = "" Then $CDDRIVE = $SystemDrive

	;Turn Error Protection Back on
	DllCall("kernel32.dll", "dword", "SetErrorMode", "dword", 0) ; SEM_FAILCRITICALERRORS
	RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Windows", "ErrorMode", "REG_DWORD", "0")

	If FileExists($CDDRIVE&"\AutoUnattend.xml") Then
		Run("X:\sources\setup.exe /unattend:" &$CDDRIVE&"\AutoUnattend.xml")
	Else
		Run("X:\sources\setup.exe")
	EndIf
	$LivePE=True
EndIf

$LastHovered = 0
$Busy=False

While 1
	If $Busy = False Then
		$MPos = MouseGetPos()
		$XP = $MPos[0] - $FormLeft - $BorderX
		$Item = Floor($XP / $Spacing) + 1
		$Skip = False
		;ConsoleWrite($MPos[0]-($FormLeft+$BorderX+($Spacing*($Item-1)))&@CRLF)
		If $MPos[0] - ($FormLeft + $BorderX + ($Spacing * ($Item - 1))) >= $IconW Then
			$Skip = True;$Item = 0
		EndIf
		;GUICtrlSetData($Label, $Item)

		;GUICtrlSetData($Label, $MPos[1] &" " & $FormTop)

		$LastHover = 0
		$Busy = True
		For $i = 1 To $TotalApps
			If $i = $Item And Not $Skip Then
				;ConsoleWrite("Here " &$i)
				If $MPos[1] > $FormTop And $MPos[1] < $FormTop + $FormHeight Then
					;GUICtrlSetData($Label, "* "&$MPos[1] &" " & $FormTop)
					If $LastHovered = 0 Then
						If FileExists(@ScriptDir & "\" & $app[$i][2] & "-Hover.png") Then
							_GUICtrlPic_SetImage($Button[$i], @ScriptDir & "\" & $app[$i][2] & "-Hover.png", 0)
						Else
							;Glenn
							_GUICtrlPic_SetImage($Button[$i], @ScriptDir & "\Unknown-Hover.png", 0)
						EndIf

						For $k= 1 To $ShCount
							GUICtrlSetData($Caption[$k], $app[$i][1])
						Next

						;GUICtrlSetData($Caption0, $app[$i][1])
						;GUICtrlSetData($Caption1, $app[$i][1])
						;GUICtrlSetData($Caption2, $app[$i][1])
						;GUICtrlSetData($Caption3, $app[$i][1])

						GUICtrlSetData($Caption4, $app[$i][1])

						GUICtrlDelete($Caption5)

						;;;GUISetFont(10, 400, 2, "Times New Roman")
						$Caption5 = GUICtrlCreateLabel($app[$i][1], $Sh, 200) ;200 if off page
						GUICtrlSetColor($Caption5, $CaptionColor)
						GUICtrlSetFont($Caption5, $CaptionFontSize, 500, 0, $CaptionFont, 4)
						GUICtrlSetBkColor($Caption5, $GUI_BKCOLOR_TRANSPARENT)

						$CPos = ControlGetPos("", "", $Caption5)
						;MsgBox (0,"",$CPos[2])


						$LastHovered = $i
						$CaptionWidth = 1000
						If IsArray($CPos) Then
							If $CPos[2] > 0 Then $CaptionWidth = $CPos[2]
						EndIf
						If $CaptionWidth < 200 Then $CaptionWidth = 200

						;_WinAPI_SetWindowPos($Form2, $HWND_TOPMOST, $FormLeft, $FormTop - $CaptionHeight - $CaptionSpace, $CaptionWidth, $CaptionHeight, BitOR($SWP_SHOWWINDOW, $SWP_NOACTIVATE))
						;GUISetState(@SW_SHOW, $Form2)
					EndIf
					$CapPos = ($FormLeft + $XP) - ($CaptionWidth / 2)
					If $CapPos <= 0 Then $CapPos = 0
					_WinAPI_SetWindowPos($Form2, $HWND_TOPMOST, $CapPos, $FormTop - $CaptionHeight - $CaptionSpace, $CaptionWidth+28, $CaptionHeight, BitOR($SWP_SHOWWINDOW, $SWP_NOACTIVATE))
					$LastHover = $i
					$app[$i][4] = True
				EndIf
			Else
				If $app[$i][4] = True Then
					If FileExists(@ScriptDir & "\" & $app[$i][2] & ".png") Then
						_GUICtrlPic_SetImage($Button[$i], @ScriptDir & "\" & $app[$i][2] & ".png", 0)
					Else
						;Glenn
						_GUICtrlPic_SetImage($Button[$i], @ScriptDir & "\Unknown.png", 0)
					EndIf
					$app[$i][4] = False
					If $LastHovered = $i Then
						$LastHovered = 0
						_WinAPI_SetWindowPos($Form2, $HWND_TOPMOST, $CapPos, $FormTop - $CaptionHeight - $CaptionSpace, $CaptionWidth+28, $CaptionHeight, BitOR($SWP_HIDEWINDOW, $SWP_NOACTIVATE))
						;Don't Leave Old Titles
					EndIf
				EndIf
			EndIf
		Next
		$Busy = False
		If $LastHover = 0 Then _WinAPI_SetWindowPos($Form2, $HWND_TOPMOST, $FormLeft, $FormTop - $CaptionHeight - $CaptionSpace, $CaptionWidth, $CaptionHeight, BitOR($SWP_HIDEWINDOW, $SWP_NOACTIVATE)) ;Hide lable

		$ReadMouse = GUIGetCursorInfo() ; Pos mouse
		If IsArray($ReadMouse) = 1 Then

			If $ReadMouse[3] Then;Right Click
				;If $LastHover = 0 Then ;Disable to Right Click quits everywhere not just on blank areas
				If $LivePE = False Then
					Sleep(100)
					Exit
				EndIf
				$Resp=MsgBox(4,"Quit/Reboot PC?", "Quit, or Reboot PC if using Win Setup?")
				If $Resp = $IDYES Then Exit
				;EndIf
			EndIf
			If $ReadMouse[2] And $LastHover <> 0 Then ;Left Click
				If FileExists(@ScriptDir & "\" & $app[$LastHover][2] & "-Press.png") Then
					_GUICtrlPic_SetImage($Button[$LastHover], @ScriptDir & "\" & $app[$LastHover][2] & "-Press.png", 0)
				Else
					;Glenn
					_GUICtrlPic_SetImage($Button[$LastHover], @ScriptDir & "\Unknown-Press.png", 0)
				EndIf
				Run(RepVar($app[$LastHover][3]))
				;MsgBox(0,"",Chr(34)&RepVar($app[$LastHover][3])&Chr(34))
				Sleep(200)
			EndIf

			Switch GUIGetMsg()
				case -3 ; $GUI_EVENT_CLOSE
					;exit ;Disable Quitting when Remarked out
					;If $LivePE = False Then Exit
					$Resp=MsgBox(4,"Quit/Reboot PC?", "Quit, or Reboot PC if using Win Setup?")
					If $Resp = $IDYES Then Exit
			EndSwitch
		EndIf
		Sleep(40)
		;$LastHover = 0
	EndIf
Wend
Exit

Func RepVar($Nam)
	$Nam = StringLower(StringReplace($Nam, "%apppath%", @ScriptDir))
	Return $Nam
EndFunc   ;==>RepVar
